/*

*/
import java.util.function.Function;

public class MakeAdder
{
   public static void main(String args[])
   {
      Function<Integer, Function<Integer,Integer>> makeAdder = x -> (y -> x + y);

      Function<Integer,Integer> add4 = makeAdder.apply(4);
      Function<Integer,Integer> add5 = makeAdder.apply(5);

      System.out.println( add4.apply(5) );
      System.out.println( add5.apply(5) );
      System.out.println( add4 );
      System.out.println( add5 );
   }
}
